enum entity {client,server};
struct plaintext
{
        int  seq_no;  
	int length;
	char *content;
};
typedef struct plaintext plain;

struct genericblock
{
	char content[50];
	char mac[20];
	char padding;
	char length;

};
typedef struct genericblock generic;

struct ciphertext
{
	int	seq_no;
	int 	length;
	char	fragment[80];
};

typedef struct ciphertext cipher;

struct sec_param
{
	char	key_size;
	char	iv_size;
	char 	mac_key_size;
	char  	mac_size;
        char	key_material_length;
	char	*client_key;
	char	*server_key;
	char 	*client_mac_secret;
	char 	*server_mac_secret;
	char	*client_iv;
	char	*server_iv;
	char	*master_secret;
	char	client_random[16];
	char	server_random[16];
	char	key_refresh;

};

typedef struct sec_param parameters;

struct DHparameters
{
	char dh_e;
	char dh_p[130];
	char dh_g[130];
};
typedef struct DHparameters DHparam;
struct client_hello
{
	char client_version;
	char random[16];
	char session_id;
	DHparam key_id;
	char key_refresh;
};
typedef struct client_hello CH;

struct server_hello
{
	char server_version;
	char random[16];
	char session_id;
	char key_refresh;
};
typedef struct server_hello SH;
struct server_hello_done
{
};
typedef struct server_hello_done SHD;
struct finished
{
	char verify_data[8];
};
typedef struct finished FD;
struct change_cipher_spec
{
	unsigned char change_message :1;
};
typedef struct change_cipher_spec CCS;

