#include<stdio.h>
#include "dummy.h"
#include "hmac.h"
#include "des.h"
	
char* calculate_master(char* premaster_secret,char* cr,char* sr)
{
     char* conc;
     int i;
     conc = (char*)malloc(sizeof(char)*32);
     bcopy(cr,conc,16);
     bcopy(sr,conc+16,16);
     //disp(conc,32);
     return(PRF(premaster_secret,"master secret",conc,32,20));
}

char* key_block(char* master,char* ex_label,int seq_num,char* cr,char*sr,int block_len)
{
     char* conc;
     int i;
     char num[5];
     i=sprintf(num,"%d",seq_num);
     conc = (char*)malloc(sizeof(char)*(32+i));
     bcopy(num,conc,i);
     bcopy(sr,conc+i,16);
     bcopy(cr,conc+i+16,16);
     //disp(conc,32+i);
     return(PRF(master,ex_label,conc,32+sizeof(seq_num),block_len));
}     
 
char* write_en_key(char* key,char* label,char* cr,char* sr,int block_len)
{
     char* conc;
     conc = (char*)malloc(sizeof(char)*32);
     bcopy(sr,conc,16);
     bcopy(cr,conc+16,16);
     return(PRF(key,label,conc,32,block_len));
}

char* iv_block(int seq_num,char* cr,char* sr,int block_len)
{
     char* conc;
     conc = (char*)malloc(sizeof(char)*36);
     bcopy(seq_num,conc,4);
     bcopy(sr,conc+4,16);
     bcopy(cr,conc+20,16);
     return(PRF("","IV block",conc,36,block_len));
}

void initialize(parameters *a)
{
   a->key_size = 8;
   a->iv_size  = 8;
   a->mac_key_size=20;
   a->mac_size=20;
   a->key_refresh = 5;
   a->master_secret=(char*)malloc(sizeof(char)*20);
   a->server_key = (char*)malloc(sizeof(char)*a->key_size);
   a->client_key = (char*)malloc(sizeof(char)*a->key_size);
   a->client_iv  = (char*)malloc(sizeof(char)*a->iv_size);
   a->server_iv  = (char*)malloc(sizeof(char)*a->iv_size);
   a->client_mac_secret=(char*)malloc(sizeof(char)*a->mac_size);
   a->server_mac_secret=(char*)malloc(sizeof(char)*a->mac_size);
}   
void calculate(parameters *p,int seq_num,char* label,int en)
{
        char* keyblock;
	keyblock =key_block(p->master_secret,label,seq_num,p->client_random,p->server_random,p->key_size+p->iv_size);
	if(en==client)
	{
	bcopy(keyblock,p->client_mac_secret,p->mac_size);
	bcopy(keyblock+p->mac_size,p->client_key,p->key_size);
	bcopy(keyblock+p->mac_size+p->key_size,p->client_iv,p->iv_size);
	p->client_key=write_en_key(p->client_key,"client write key",p->client_random,p->server_random,p->key_size);
	}
	else
	{
	bcopy(keyblock,p->server_mac_secret,p->mac_size);
	bcopy(keyblock+p->mac_size,p->server_key,p->key_size);
	bcopy(keyblock+p->mac_size+p->key_size,p->server_iv,p->iv_size);
	p->server_key=write_en_key(p->server_key,"server write key",p->client_random,p->server_random,p->key_size);
	}
}
void print(char *str,int size)
{
	int i;
	for(i=0;i<size;i++)
		printf("%d##",str[i]);
}

void display(parameters p)
{
	printf(" client key is \n");
	print(p.client_key,p.key_size);
	printf(" server key is \n");
	print(p.server_key,p.key_size);
	printf(" client iv is \n");
	print(p.client_iv,p.iv_size);
	printf(" server iv is \n");
	print(p.server_iv,p.iv_size);
}

void initial(plain *p_text,int seq_num,int no_char,char* input)
{
	p_text->seq_no = seq_num;
	p_text->length = no_char;
	p_text->content = (char*)malloc(sizeof(char)*no_char);
	bcopy(input,p_text->content,p_text->length);
}	
initial_ch(CH *client)
{
	int i;

	for(i=0;i<16;i++)
	client->random[i]=rand()%10;
	client->client_version=1;
	client->key_refresh=8;
	client->key_id.dh_e=0;
	strcpy(client->key_id.dh_p,"3a2b3c4d5e6f758b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d526f738b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b");
	strcpy(client->key_id.dh_g,"33");
}
response(SH *server,CH *client)
{
	int i;
	server->server_version=1;
	server->key_refresh=rand()%client->key_refresh +1;
	for(i=0;i<16;i++)
	server->random[i]=rand()%19;
}
char * form_server_message(SH *ser,char *public,SHD *shdm)
{
	char *result;
	result =(char*)malloc(sizeof(char)*(sizeof(SH)+sizeof(SHD)+130));
	bcopy((char*)ser,result,sizeof(SH));
	bcopy(public,result+sizeof(SH),130);
	bcopy((char*)shdm,result+sizeof(SH)+130,sizeof(SHD));
	return(result);
}
void  get_message(char *result,SH *ser,char *public,SHD *shdm)
{
	bcopy(result,(char*)ser,sizeof(SH));
	bcopy(result+sizeof(SH),public,130);
	bcopy(result+sizeof(SH)+130,(char*)shdm,sizeof(SHD));
}
void calculate_client_finished(FD *fd,CH* cli_hello,char *response,char* cli_public,char *master)
{
	char *result;
	int len;
	result=(char*)malloc(sizeof(char)*(sizeof(CH)+sizeof(SH)+260+sizeof(SHD)));
	bcopy((char*)cli_hello,result,len=sizeof(CH));
	bcopy(response,result+len,sizeof(SH)+130+sizeof(SHD));
	len+=sizeof(SH)+130+sizeof(SHD);
	bcopy(cli_public,result+len,130);
	bcopy(PRF(master,"client finished",sha(result,len+130),20,8),fd->verify_data,8);
}
char *form_client_response(char* public,CCS *ccd,char *encfd)
{	
	char *result;
	int len;
	result=(char*)malloc(sizeof(char)*(130+sizeof(CCS)+sizeof(FD)));
	bcopy(public,result,len=130);
	bcopy((char*)ccd,result+len,sizeof(CCS));
	len+=sizeof(CCS);
	bcopy(encfd,result+len,sizeof(FD));
//	disp(encfd,12);
	return(result);
}
void calculate_server_finished(FD *fd,CH* cli_hello,char *ser_response,char* cli_response,char *master)
{
	char *result;
	int len;
	result=(char*)malloc(sizeof(char)*(sizeof(CH)+sizeof(SH)+260+sizeof(SHD)+sizeof(FD)));
	bcopy((char*)cli_hello,result,len=sizeof(CH));
	bcopy(ser_response,result+len,sizeof(SH)+130+sizeof(SHD));
	len+=sizeof(SH)+130+sizeof(SHD);
	bcopy(cli_response,result+len,130);
	len+=130;
	bcopy(cli_response+len+sizeof(CCS),result+len,sizeof(FD));
	bcopy(PRF(master,"server finished",sha(result,len+sizeof(FD)),20,8),fd->verify_data,8);
}
int verify_server_finished(FD *serfd,CH* cli_hello,char *ser_response,char* cli_response,char *master)
{
	FD temp;
	calculate_server_finished(&temp,cli_hello,ser_response,cli_response,master);
	if(strncmp(temp.verify_data,serfd->verify_data,8)==0)
		return(1);
	else	
		return(0);
}
int verify_client_finished(FD *clifd,CH* cli_hello,char *ser_response,char* cli_public,char *master)
{
	FD temp;
	calculate_client_finished(&temp,cli_hello,ser_response,cli_public,master);
	if(strncmp(temp.verify_data,clifd->verify_data,8)==0)
		return(1);
	else	
		return(0);
}
int check_client_response(char *client_response,CH* cli_hello,char *ser_response,char *cli_public,parameters *p)
{
	CCS ccsp;
	FD fd,clifd;

	bcopy(client_response+130,(char*)&ccsp,sizeof(CCS));
	if(ccsp.change_message==1)
	{
		bcopy(client_response+130+sizeof(CCS),(char*)&fd,sizeof(fd));
		bcopy(decode(fd.verify_data,p->client_key,p->client_iv,8),clifd.verify_data,8);
		return(!verify_client_finished(&clifd,cli_hello,ser_response,cli_public,p->master_secret));
	}
	return(1);
}
