#include "inet.h"
#include "deff.h"
#include "key_block.h"

main()
{
   int	sockfd,i,seq_num=0,no_char;
   struct sockaddr_in    cli_addr,serv_addr;
   FILE *fp;
   SHD shd;
   parameters p;
   plain p_text;
   char  input[50];
   int serlen=sizeof(serv_addr),len;
   char premaster_secret[20];
   char *serv_finished;
   cipher  c;
   generic gblock;
   CH cli_hello;
   SH serv_hello;
   char private_key[130];
   char serv_public[130],cli_public[130],keyc[130];
   char *serv_response;
   char file[16];
   CCS ccsp;
   FD fd;
   char *client_response;
//   strcpy(private_key,"1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b");
   serv_response=(char*)malloc(sizeof(char)*(sizeof(SH)+sizeof(SHD)+130));
   seq_num = 0;
 	system("clear");
	printf("login: ");
	scanf("%s",serv_public);
	printf("password: ");
	system("stty -echo");
	scanf("%s",private_key);
	system("stty echo");
	bcopy(serv_public,private_key+strlen(private_key),strlen(serv_public));
   bzero((char *) &serv_addr,sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
   serv_addr.sin_port = htons(SERV_UDP_PORT);

   if( (sockfd = socket(AF_INET,SOCK_DGRAM,0)) < 0)
      printf("\n client error");

   bzero((char *) &cli_addr,sizeof(cli_addr));   
   cli_addr.sin_family = AF_INET;
   cli_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   cli_addr.sin_port = htons(0);

  
   if(bind(sockfd,(struct sockaddr *) &cli_addr,sizeof(cli_addr))<0)
       printf("\n bind error ");

   printf("\n client running ");
   initialize(&p);
   initial_ch(&cli_hello);
   bcopy(cli_hello.random,p.client_random,16);

	if((sendto(sockfd,(char*)&cli_hello,sizeof(cli_hello),0,(struct sockaddr*)&serv_addr,sizeof(serv_addr)))!=sizeof(cli_hello))
		error("sending client hello");
	else
		printf("sent client hello\n");
		
	if((recvfrom(sockfd,serv_response,sizeof(SH)+sizeof(SHD)+130,0,(struct sockaddr*)&serv_addr,&serlen))<0)
		error("recieving server response");
	else
		printf("recieved server response\n");
		
	get_message(serv_response,&serv_hello,serv_public,&shd);
	
   	p.key_refresh=serv_hello.key_refresh;
	bcopy(serv_hello.random,p.server_random,16);
	len=deff(cli_public,cli_hello.key_id.dh_g,private_key,cli_hello.key_id.dh_p);
	len=deff(keyc,serv_public,private_key,cli_hello.key_id.dh_p);
	bcopy(keyc,premaster_secret,20);
	printf("The premaster secret in client is\n");
	disp(premaster_secret,20);
	bcopy(calculate_master(premaster_secret,p.client_random,p.server_random),p.master_secret,20);
	printf("The master secret calculated is \n");
	disp(p.master_secret,20);
	
	ccsp.change_message=1;
	calculate_client_finished(&fd,&cli_hello,serv_response,cli_public,p.master_secret);
        calculate(&p,seq_num,"client expansion",client);
	bcopy(encode(fd.verify_data,p.client_key,p.client_iv,8),fd.verify_data,8);
	client_response=form_client_response(cli_public,&ccsp,(char*)&fd);

	if(sendto(sockfd,client_response,len=(sizeof(CCS)+130+sizeof(FD)),0,(struct sockaddr*)&serv_addr,sizeof(serv_addr))!=len)
		error("sending client response");
	else
		printf("sent client response\n");
		

	if((recvfrom(sockfd,(char*)&fd,sizeof(FD),0,(struct sockaddr*)&serv_addr,&serlen))<0)
		error("recieving server finished");
	else
		printf("recieved server finished\n");
	calculate(&p,seq_num,"server expansion",server);
	bcopy(decode(fd.verify_data,p.server_key,p.server_iv,8),fd.verify_data,8);
	if(verify_server_finished(&fd,&cli_hello,serv_response,client_response,p.master_secret))
	{
		printf("\nillegal finished message from server\n");
		close(sockfd);
		exit(1);
	}
do
{
	do
	{
	printf("\nfile name to be transferred :\n");
	scanf("%s",file);
	fp=fopen(file,"r");
	}while(!fp);

	while(!feof(fp))
	{
	if(seq_num%p.key_refresh == 0)
	{
	   calculate(&p,seq_num,"client expansion",client);
	   calculate(&p,seq_num,"server expansion",server);
	}
	no_char = fread(input,sizeof(char),50,fp);
	initial(&p_text,seq_num,no_char,input);
	bcopy(p_text.content,gblock.content,no_char);
	bcopy(hmac_sha(p.client_mac_secret,p_text.content,no_char),gblock.mac,20);
        c.seq_no = seq_num;
        c.length = sizeof(gblock);
        gblock.length = no_char;
        bcopy(encode((char*)&gblock,p.client_key,p.client_iv,c.length),c.fragment,c.length);
	printf("encoded block no. %d \n",seq_num);
	disp(c.fragment,c.length);
	if((sendto(sockfd,(char*)&c,sizeof(c),0,(struct sockaddr*)&serv_addr,sizeof(serv_addr)))!=sizeof(c))
	error("sending client encode");
	++seq_num;
	}	
	fclose(fp);
	printf("do you want to continue\n");
	fflush(stdin);
	file[0]=getchar();
	scanf("%c",&file[0]);
}
	while(file[0]!='n');
	close(sockfd);
}

